#include <iostream>
#include "TreeNode.h"
#include <time.h>
#include <stdio.h>
#include "ParameterList.h"
#include "StereoBuffer16.h"
#include "MonoBuffer16.h"
#include "NoiseBandSynthesizer.h"

#include "SaxHackSynthesizer.h"
//#include "ParamOutputSynthesizer.h"
#include "handyfuncs.h"

int main (int argc, char * const argv[]) {
    // insert code here...
//    std::cout << "Hello, World!\n";
   int  stime;
  long ltime;

  /* get the current calendar time */
  ltime = time(NULL);
  stime = (unsigned) ltime/2;
  srand(stime);


   TreeNode* tree;
   ParameterList params;
   
   tree=new TreeNode(0);
   
   /*
   
enum Parameter
{
   eAmplitude=0,
   eCenterFrequency,
   eBandwidth,
   eLength,
   eSkip,
   eRandomness,
   eMutation,
   eGrainStart,
   eShift,
   eNumParams
};

   for(int i=0;i<100;i++)
   {
      printf("value of randfloatexp2(%f)=%f\n",(float)i/99.0,randfloatexp2((float)i/99.0));
      printf("value of exp2cursor(%f)=%f\n",(float)i/99.0, exp2cursor((float)i/99.0));

   }
*/
   //we need to add each parameter manually, to set it's mins and maxes.
   //nodte that because this program was hacked together in a week that these parameters need to be
   //added in the order of their enum (enumeration).
   
   float startFreq = 1000.0;
   float spacing = 20.0;

   params.SetNumTopLayers(kMaxLayers-1);

/* for noise band*/
/*
   params.AddParameter(eAmplitude,0.3,0.0005,1.0);
   params.AddParameter(eCenterFrequency,startFreq,startFreq/spacing,startFreq*spacing);
   params.AddParameter(eBandwidth,0.3,0.01,0.9);
*/
/*for sax*/	
	params.AddParameter(eBreathPressure,127.0,0.005,128.0);
	params.AddParameter(eBlowPosition,64.0,0.0005,128.0);
	params.AddParameter(eReedStiffness,64.0,0.0005,128.0);
	params.AddParameter(eReedAperature,64.0,0.0005,128.0);
	params.AddParameter(eCenterFrequency,200,75.0,600.0);
	params.AddParameter(eVibratoFrequency,5.735*128.0/12.0,0.005,128.0); //these are set wrt the way Saxofony.cpp handles controlChange
	params.AddParameter(eVibratoGain,0.1*2*128,0.005,128.0);
	params.AddParameter(eNoiseGain,0.2*128/0.4,0.005,128.0);
	params.AddParameter(eMaxBlowLength,5.0,0.01,30.0); //in seconds
	params.AddParameter(eMaxRestLength,1.0,0.001,4.0);
 

	
//   params.AddParameter(eRandomness,0.0,0.000001,1.0);
  // params.AddParameter(eLength,0.5,0.000001,20.0);//in seconds.
   
   float duration = 60.0 * 5;
   std::vector<ParameterList*> paramLists;
   paramLists.push_back(&params);
   tree->Generate(/*startTime*/0.0,duration, &paramLists);
   
   tree->PrintFile("firsttest.txt",stime);
   tree->PrintLayerFile("layertest.txt",stime);
   tree->PrintGridFile("grridtest.txt",stime);
   
   //synth
   StereoBuffer16* mix = new StereoBuffer16();
   mix->Create((duration+4)*44100);
   
   int numLayers = tree->GetMaxLayerNum();
   char layerfilename[20];
   char paramfilename[20];
   strcpy(layerfilename,"layerX.wav");
   strcpy(paramfilename,"layerX.wav");

   for(int i=0;i<numLayers+1;i++)
   {
   
      params.ResetCoefficients();

/*for noise band*/
/*      
      params.SetParameter(eCenterFrequency,startFreq,startFreq/spacing,startFreq*spacing);
      startFreq=startFreq*(coinflip()?1.25:(1.25/1.0592));
*/      
      MonoBuffer16* buf;
      //TreeSynthesizer* synth = new NoiseBandSynthesizer(duration);
      TreeSynthesizer* synth = new SaxHackSynthesizer(duration);
  //    for(int j=1;j<2/*params.GetNumParameters()*/;j++)
//      {
//         ParamOutputSynthesizer* paramOutput = new ParamOutputSynthesizer(duration);
//         paramOutput->SetParameter((Parameter)j,params.GetMinValue((Parameter)j),params.GetMaxValue((Parameter)j));
//         params.ResetCoefficients();
//         
//         tree->Synthesize(paramOutput,&params, i);
//         buf=(MonoBuffer16*)paramOutput->GetBuffer();
//         buf->Normalize(-3.0);
//         
//         strcpy(paramfilename,"layerX, paramX.wav");
//         paramfilename[5]=i+'1';
//       
//         paramfilename[13]=j+'1';
//         buf->WriteWave(paramfilename ,0,1.0);
//
//         delete paramOutput;
//      }
      
      
      tree->Synthesize(synth,&params, i);
      buf=(MonoBuffer16*)synth->GetBuffer();
      //layer zero and layer numLayer-1 are the most similar so make sure to put them around the back.
      printf("buf %i peak = %f",i,((MonoBuffer16*)synth->GetBuffer())->GetPeak());
     // buf->Normalize(-3.0);

      mix->Mix(buf,1.0*44100,1.0,((i==0?numLayers-1:(i-1))+0.5)/((float)numLayers));
      
      layerfilename[5]=i+'1';
      buf->WriteWave(layerfilename,0,1.0);
      delete synth;
   }
   mix->Normalize(-3.0);
   mix->WriteWave("TreeMusic.wav",0,1.0);
   
   delete tree;
    
        return 0;
}
